﻿using System;
using System.IO;
using System.Linq;
using System.Reflection;

namespace HeaderFix
{
    static class Program
    {
        static void Main()
        {
            //Search current directory for *.odex files
            var searchPath = Path.GetDirectoryName(Assembly.GetEntryAssembly().Location);
            var odexFiles = Directory.EnumerateFiles(searchPath, "*.odex").ToList();

            Console.WriteLine("Found " + odexFiles.Count() + " odex files.");
            foreach (var odexFile in odexFiles)
            {
                Console.WriteLine("Fixing: " + Path.GetFileName(odexFile));
                try
                {
                    //Read all bytes, fix the first 8 
                    var bytes = File.ReadAllBytes(odexFile);
                    bytes[0] = 0x64;
                    bytes[1] = 0x65;
                    bytes[2] = 0x79;
                    bytes[3] = 0x0a;
                    bytes[4] = 0x30;
                    bytes[5] = 0x33;
                    bytes[6] = 0x35;
                    bytes[7] = 0x0;

                    //And write everything back to disk
                    File.WriteAllBytes(odexFile, bytes);
                }
                catch (Exception e)
                {
                    //not much we can do here, probably some missing file system permissions
                    Console.WriteLine("Error: " + e.Message);
                }
            }

            Console.WriteLine("Done.");
            Console.ReadKey();
        }
    }
}
